

#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#define _LINUX_TIME_H 1	/* to get things compile on kernel 2.6.x */
#include <linux/videodev.h>


#include "m_pd.h"
#include "pwc-ioctl.h"

char *device = "/dev/video0";

static t_class *setpwc_class;

typedef struct _setpwc {
  t_object  x_obj;
} t_setpwc;

void check_device(int *fd)
{
	if (*fd == -1)
	{
		/* open device */
		*fd = open(device, O_RDWR);
		if (*fd == -1)
		{
			post("Error while accessing device");
//			exit(1);
		}
	}
}

void restore_settings(int fd)
{
	if (ioctl(fd, VIDIOCPWCRUSER) == -1)
		perror("VIDIOCPWCRUSER");
}

void setpwc_bang(t_setpwc *x)
{
	int fd = -1;
 	check_device(&fd);
	restore_settings(fd);
}

void *setpwc_new(void)
{
  t_setpwc *x = (t_setpwc *)pd_new(setpwc_class);

  return (void *)x;
}

void setpwc_setup(void) {
  setpwc_class = class_new(gensym("setpwc"),
        (t_newmethod)setpwc_new,
        0, sizeof(t_setpwc),
        CLASS_DEFAULT, 0);
  class_addbang(setpwc_class, setpwc_bang);
}
